/* ******************************************************************

   author     : puehringer edgar

   compiler   : javac (jdk 1.1.6)

   class      : Const
   date       : 15.07.98
   description: global available constants

*********************************************************************/

/* ******************************************************************
   top level class declaration
*********************************************************************/

public abstract class Const {

  // class variable declarations

  // Resources
  /** The key to the desktop settings property file name */
  public static final String DESKTOP_NAME = "desktopFile";
  /** The key to the name to display for a untitled file */
  public static final String UNTITLED_NAME = "untitled";
  /** The key to the save confirm dialog text */
  public static final String SAVECONFIRM_TEXT = "saveConfirmDlg.Text";
  /** A key to the revert confirm dialog text */
  public static final String REVERTCONFIRM_TEXT1 = "revertConfirmDlg.Text1";
  /** A key to the revert confirm dialog text */
  public static final String REVERTCONFIRM_TEXT2 = "revertConfirmDlg.Text2";
  /** A key to the auto save confirm dialog text */
  public static final String AUTOSAVE_TEXT1 = "autoSaveDlg.Text1";
  /** A key to the auto save confirm dialog text */
  public static final String AUTOSAVE_TEXT2 = "autoSaveDlg.Text2";
  /** The key to the auto save options dialog */
  public static final String AUTOSAVE_OPTIONS = "autoSaveOptionsDlg.";
  /** The key to the help window class resource */
  public static final String HELP_CLASS = "helpWindowClass";

  // Desktop properties
  /** Key to the auto save time resource */
  public static final String AUTOSAVE_TIME = "autoSaveTime";
  /** Key to the auto save enabled resource */
  public static final String AUTOSAVE_ENBL = "autoSaveEnabled";
  /** Key to the auto-save on compile property */
  public static final String ASOC_PROP = "autoSaveOnCompile";

  // Project properties
  /** Key to the project extension resource */
  public static final String PROJECT_EXT = "projectExtension";
  /** Key to the source extension resource */
  public static final String SOURCE_EXT = "sourceExtension";
  /** Key to the object extension resource */
  public static final String OBJECT_EXT = "objectExtension";
  /** Key to the runnable extension resource */
  public static final String EXEC_EXT = "execExtension";
  /** Key to the source code template extension resource */
  public static final String TPL_EXT = "templateExtension";
  /** Key to the project directory resource */
  public static final String PROJECT_DIR = "projectDir";
  /** Key to the source code template directory resource */
  public static final String TEMPLATE_DIR = "templateDir";
  /** Key to the number of files resource */
  public static final String NUM_FILES = "numberOfFiles";
  /** Prefix to a file key */
  public static final String FILE_PREFIX = "file";
  /** Key to the number of executable files resource */
  public static final String NUM_EXEC = "numberOfExecutables";
  /** Prefix to a object file key */
  public static final String OBJECT_PREFIX = "object";
  /** Key to the number of object files resource */
  public static final String NUM_OBJECT = "numberOfObjects";
  /** Prefix to a executable file key */
  public static final String EXEC_PREFIX = "executable";
  /** Key that indicates if the project file was changed */
  public static final String PROJECT_CHANGED = "changed";
  /** Key to the tab size resource */
  public static final String TAB_SIZE = "tabSize";
  /** Key to the use tabulator to store files resource */
  public static final String USE_TABS = "useTabs";
  /** Key to the file format resource */
  public static final String FILE_FORMAT = "fileFormat";
  /** Key to the copy on load key list */
  public static final String COPY_ON_LOAD = "copyOnLoad";
  /** Key to the project file path for save operations */
  public static final String PROJECTFILE_PATH = "projectFilePath";
  /** The key to the magic key, which identifies project files */
  public static final String MAGIC_KEY = "magicKey";
  /** The key to the execute command line parameters */
  public static final String CMD_LINE_PARAM = "cmdLineParam";
  /** The key to the compiler version */
  public static final String COMPILER_VERSION = "compilerVersion";
  /** The key to the newest applet class file. */
  public static final String CUR_APPLET = "curApplet";
  /** The key to the relative directory of the assert class file. */
  public static final String CUR_ASSERT = "curAssertRelDir";

  // Mini piture keys
  /** Key to the directory mini picture */
  public static final String DIR_IMAGE = "dirIcon";
  /** Key to the document mini picture */
  public static final String DOC_IMAGE = "docIcon";
  /** Key to the runnable mini picture */
  public static final String EXEC_IMAGE = "runIcon";
  /** Key to the error mini picture */
  public static final String ERROR_IMAGE = "errorSymbol";
  /** Key to the warning mini picture */
  public static final String WARNING_IMAGE = "warningSymbol";
  /** Key to the compile success mini picture */
  public static final String SUCCESS_IMAGE = "successSymbol";

  // Frequently used action identifiers */
  /** Identifier of the new action */
  public static final String NEW_ACTION = "new";
  /** Identifier of the alternative new action */
  public static final String ALTNEW_ACTION = "alt-new";
  /** Identifier of the new window action */
  public static final String NEWWINDOW_ACTION = "new-window";
  /** Identifier of the open action */
  public static final String OPEN_ACTION = "open";
  /** Identifier of the save action */
  public static final String SAVE_ACTION = "save";
  /** Identifier of the save as action */
  public static final String SAVEAS_ACTION = "save-as";
  /** Identifier of the revert action */
  public static final String REVERT_ACTION = "revert";
  /** Identifier of the close action */
  public static final String CLOSE_ACTION = "close";
  /** Identifier of the exit action */
  public static final String EXIT_ACTION = "exit";
  /** Identifier of the auto save action */
  public static final String AUTOSAVE_ACTION = "auto-save";

} // end Const

/* ******************************************************************
   end of file
*********************************************************************/
