/* ******************************************************************

   class    : ImageCanvas
   date     : 22.07.98
   compiler : javac (jdk 1.1.6)

*********************************************************************/

package CustCtrl;

/* ******************************************************************
   import statements
*********************************************************************/

import java.awt.*;

/**
 *
 * A canvas that draws an image.
 *
 * @author puehringer edgar
 *
 */
public class ImageCanvas extends Canvas {

  // class variable declarations

  // instance variable declarations
  /** The image to display. */
  protected Image image;

  // constructors
  /** Create a new ImageCanvas object. */
  public ImageCanvas(Image image) {
    this.image = image;
  } // end constructor ImageCanvas

  // methods
  public void paint(Graphics g) {
    g.drawImage(image,0,0,image.getWidth(this),
                image.getHeight(this),this);
  } // end paint

  public Dimension getPreferredSize() {
    return getMinimumSize();
  } // end getPreferredSize

  public Dimension getMinimumSize() {
    return new Dimension(image.getWidth(this),
                         image.getHeight(this));
  } // end getMinimumSize

} // end ImageCanvas

/* ******************************************************************
   end of file
*********************************************************************/
