package ErrorParser;

class ErrorStream {

	int count;  // number of errors detected

	ErrorStream() {
		count = 0;
	}

	void StoreError(int n, int line, int col, String s) {
		System.out.println("-- line " + line + " col " + col + ": " + s);
	}

	void ParsErr(int n, int line, int col) {
		String s;
		count++;
		switch (n) {
			case 0: {s = "EOF expected"; break;}
			case 1: {s = "ident expected"; break;}
			case 2: {s = "integer expected"; break;}
			case 3: {s = "eol expected"; break;}
			case 4: {s = "point expected"; break;}
			case 5: {s = "double expected"; break;}
			case 6: {s = "comma expected"; break;}
			case 7: {s = "'error' expected"; break;}
			case 8: {s = "'Note' expected"; break;}
			case 9: {s = "'java' expected"; break;}
			case 10: {s = "'^' expected"; break;}
			case 11: {s = "'errors' expected"; break;}
			case 12: {s = "'warning' expected"; break;}
			case 13: {s = "'warnings' expected"; break;}
			case 14: {s = "not expected"; break;}
			case 15: {s = "invalid AllOne"; break;}
			case 16: {s = "invalid WarningRest"; break;}
			case 17: {s = "invalid LongMsg"; break;}
			case 18: {s = "invalid ShortMsg"; break;}
			case 19: {s = "invalid Summary"; break;}
			case 20: {s = "invalid Message"; break;}

			default: s = "Syntax error " + n;
		}
		StoreError(n, line, col, s);
	}

	void SemErr(int n, int line, int col) {
		String s;
		count++;
		switch (n) {
			case -1: {s = "invalid character"; break;}
			// perhaps insert application specific error messages here
			default: {s = "Semantic error " + n; break;}
		}
		StoreError(n, line, col, s);
	}

	void Exception (String s) {
		System.out.println(s); System.exit(0);
	}

	void Summarize (String s) {
		switch (count) {
			case 0 : System.out.println("No errors detected"); break;
			case 1 : System.out.println("1 error detected"); break;
			default: System.out.println(count + " errors detected"); break;
		}
	}

}
