/* ******************************************************************

   class    : ParserObservable
   date     : 30.07.98
   compiler : javac (jdk 1.1.6)

*********************************************************************/

package ErrorParser;

/* ******************************************************************
   import statements
*********************************************************************/

import java.util.Observable;

/**
 *
 * A class that notifies some observers from a parsing event.
 *
 * @author puehringer edgar
 *
 */
public class ParserObservable extends Observable {

  // instance variable declarations
  public Object object;

  // constructors
  /** Create a new ParserObservable object. */
  public ParserObservable() {
  } // end constructor ParserObservable

  // methods
  public void notify(Object obj) {
    if (obj == null) return;
    if (!obj.equals(object)) {
      object = obj;
      setChanged();
      notifyObservers(object);
    } // end if
  } // end notify

} // end ParserObservable

/* ******************************************************************
   end of file
*********************************************************************/
