/* ******************************************************************

   class    : ExitAction
   date     : 22.07.98
   compiler : javac (jdk 1.1.6)

*********************************************************************/

/* ******************************************************************
   import statements
*********************************************************************/

import java.awt.event.ActionEvent;
import com.sun.java.swing.AbstractAction;

/**
 *
 * Check if a document must be saved and destroy all hosting frames.
 *
 * @author puehringer edgar
 *
 */
class ExitAction extends AbstractAction {

  // instance variable declarations
  protected FrameManager fm;

  // constructors
  /** Create a new ExitAction class. */
  ExitAction(FrameManager fm) {
    this(fm,Const.EXIT_ACTION);
  } // end constructor ExitAction

  /** Create a new ExitAction class. */
  ExitAction(FrameManager fm, String nm) {
    super(nm);
    this.fm = fm;
  } // end constructor ExitAction


  // instance methods
  public void actionPerformed(ActionEvent e) {
    if (fm.closeAll()) {
      AbstractHelpWindow.quit();
      ProjectPanel.saveDesktopProperties();
      System.exit(0);
    } // end if
  } // end actionPerformed

} // end ExitAction

/* ******************************************************************
   end of file
*********************************************************************/
