// project: SID - Structured Interactive Documentation
// author : Dipl.Ing. Stefan Chiettini

package SID.Meta;

import java.util.*;
import java.io.*;

// concrete class to represent java attributes

public class JavaAttributeInfo extends AttributeInfo{

	static{
		modResolve = modifierPool.javaMods();
		typeResolve = modifierPool.javaTypes();
		modMax = 10;
	}

	public JavaAttributeInfo(String name, int type){
//    super(name, type); /* disabled by PE */
    super(name,(short)type); /* inserted by PE */
	}

	public JavaAttributeInfo(String name, String type){
		super(name, type);
	}

	public JavaAttributeInfo(){
		super();
	}

	public boolean isPublic(){ return isModifierSet("public"); }
	public boolean isPrivate(){ return isModifierSet("private"); }
	public boolean isProtected(){ return isModifierSet("protected"); }
}


