// project: SID - Structured Interactive Documentation
// author : Dipl.Ing. Stefan Chiettini

package SID.Meta;

import java.util.*;
import java.io.*;

public class modifierPool{

	private Hashtable codePool;
	private Hashtable stringPool;

	public modifierPool(){
		codePool = new Hashtable(15);
		stringPool = new Hashtable(15);
	}

	public String mapMod(int m){
		String s = (String)codePool.get(new Integer(m));
		if (s == null) s = "unknown";
		return s;
	}

	public int mapMod(String s){
		Integer i = ((Integer)stringPool.get(s));

		if (i == null){
			insert(stringPool.size()+1, s);
			i = ((Integer)stringPool.get(s));
		}

		return i.intValue();
	}

	public void insert(int m, String s){
		codePool.put(new Integer(m), s);
		stringPool.put(s, new Integer(m));
	}

	public void remove(int m){
		Object o = codePool.get(new Integer(m));
		if (o != null){
			codePool.remove(new Integer(m));
			stringPool.remove((String)o);
		}
	}

	public void remove(String s){
		Object o = stringPool.get(s);
		if (o != null){
			stringPool.remove(s);
			codePool.remove((Integer)o);
		}
	}

	public String resolveModifiers(BitSet modifiers){
		String retString = "";
		int i; 
		int len = modifiers.size();

		for (i=0; i < len; i++){
			if (modifiers.get(i)){
				retString += mapMod(i) + " ";
			}						
		}

		return retString;
	}

	// build a pool for java modifiers:
	public static modifierPool javaMods(){
		modifierPool m = new modifierPool();
		m.insert(1, "public");
		m.insert(2, "private");
		m.insert(3, "protected");
		m.insert(4, "static");
		m.insert(5, "abstract");
		m.insert(6, "final");
		m.insert(7, "synchronized");
		m.insert(8, "native");
		m.insert(9, "volatile");
		m.insert(10, "transient");
		return m;
	}

	// build a pool for java base types
	public static modifierPool javaTypes(){
		modifierPool m = new modifierPool();
		m.insert(0, "byte");
		m.insert(1, "short");
		m.insert(2, "int");
		m.insert(3, "long");
		m.insert(4, "float");
		m.insert(5, "double");
		m.insert(6, "char");
		m.insert(7, "boolean");
		m.insert(8, "void");
		return m;
	}
}