package SID.Parser;
import java.util.*;

import SID.Meta.*;
//import SID.Meta.Parameter;

public class Parser {
	static final int maxT = 85;
	static final int maxP = 85;

	static final boolean T = true;
	static final boolean x = false;
	
	static Token t;				// lookahead token
	static Token token;			// last recognized token

	private static modifierPool mod = modifierPool.javaMods();

	public static Vector parsedClasses = new Vector(2);

	static private void Error(int n) {
		Scanner.err.ParsErr(n, t.line, t.col);
	}
	
	static private void Get() {
		for (;;) {
			token = t;
			t = Scanner.Scan();
			if (t.kind<=maxT) return;

			t = token;
		}
	}
	
	static private void Expect(int n) {
		if (t.kind==n) Get(); else Error(n);
	}
	
	static private boolean StartOf(int s) {
		return set[s][t.kind];
	}
	
	static private void ExpectWeak(int n, int follow) {
		if (t.kind == n) Get();
		else {
			Error(n);
			while (!StartOf(follow)) Get();
		}
	}
	
	static private boolean WeakSeparator(int n, int syFol, int repFol) {
		boolean[] s = new boolean[maxT+1];
		if (t.kind==n) {Get(); return true;}
		else if (StartOf(repFol)) return false;
		else {
			for (int i=0; i<=maxT; i++) {
				s[i] = set[syFol][i] || set[repFol][i] || set[0][i];
			}
			Error(n);
			while (!s[t.kind]) Get();
			return StartOf(syFol);
		}
	}
	
	private static void ArgumentList() {
		Expr();
		while (t.kind==24) {
			Get();
			Expr();
		}
	}

	private static void Primary() {
		String dummy; 
		switch (t.kind) {
		case 2: {
			Get();
			break;
		}
		case 3: {
			Get();
			break;
		}
		case 4: {
			Get();
			break;
		}
		case 5: {
			Get();
			break;
		}
		case 68: {
			Get();
			break;
		}
		case 69: {
			Get();
			break;
		}
		case 70: {
			Get();
			break;
		}
		case 1: {
			Get();
			break;
		}
		case 71: {
			Get();
			break;
		}
		case 72: {
			Get();
			break;
		}
		case 31: {
			Get();
			if (StartOf(1)) {
				Expr();
			} else if (StartOf(2)) {
				dummy = PrimitiveType();
			} else Error(86);
			Expect(32);
			if (StartOf(3)) {
				Primary();
			}
			break;
		}
		case 73: {
			Get();
			if (StartOf(2)) {
				dummy = PrimitiveType();
				Expect(28);
				Expr();
				Expect(29);
			} else if (t.kind==1) {
				dummy = Name();
				if (t.kind==28) {
					Get();
					Expr();
					Expect(29);
				} else if (t.kind==31) {
					Get();
					if (StartOf(1)) {
						ArgumentList();
					}
					Expect(32);
				} else Error(87);
			} else Error(88);
			break;
		}
		default: Error(89);
		}
		while (t.kind==9 || t.kind==28 || t.kind==31) {
			if (t.kind==9) {
				Get();
				if (t.kind==1) {
					Get();
				} else if (t.kind==21) {
					Get();
				} else Error(90);
			} else if (t.kind==28) {
				Get();
				if (StartOf(1)) {
					Expr();
				}
				Expect(29);
			} else {
				Get();
				if (StartOf(1)) {
					ArgumentList();
				}
				Expect(32);
			}
		}
	}

	private static void UnaryExpr0() {
		if (t.kind==66 || t.kind==67) {
			if (t.kind==66) {
				Get();
			} else {
				Get();
			}
			UnaryExpr();
		} else if (StartOf(3)) {
			Primary();
			while (t.kind==64 || t.kind==65) {
				if (t.kind==64) {
					Get();
				} else {
					Get();
				}
			}
		} else Error(91);
	}

	private static void UnaryExpr() {
		while (StartOf(4)) {
			if (t.kind==64) {
				Get();
			} else if (t.kind==65) {
				Get();
			} else if (t.kind==60) {
				Get();
			} else {
				Get();
			}
		}
		UnaryExpr0();
	}

	private static void MultExpr() {
		UnaryExpr();
		while (t.kind==10 || t.kind==62 || t.kind==63) {
			if (t.kind==10) {
				Get();
			} else if (t.kind==62) {
				Get();
			} else {
				Get();
			}
			UnaryExpr();
		}
	}

	private static void AddExpr() {
		MultExpr();
		while (t.kind==60 || t.kind==61) {
			if (t.kind==60) {
				Get();
			} else {
				Get();
			}
			MultExpr();
		}
	}

	private static void ShiftExpr() {
		AddExpr();
		while (t.kind==57 || t.kind==58 || t.kind==59) {
			if (t.kind==57) {
				Get();
			} else if (t.kind==58) {
				Get();
			} else {
				Get();
			}
			AddExpr();
		}
	}

	private static void RelExpr() {
		String dummy; 
		ShiftExpr();
		while (StartOf(5)) {
			if (t.kind==52) {
				Get();
			} else if (t.kind==53) {
				Get();
			} else if (t.kind==54) {
				Get();
			} else {
				Get();
			}
			ShiftExpr();
		}
		if (t.kind==56) {
			Get();
			dummy = Type();
		}
	}

	private static void EqualityExpr() {
		RelExpr();
		while (t.kind==50 || t.kind==51) {
			if (t.kind==50) {
				Get();
			} else {
				Get();
			}
			RelExpr();
		}
	}

	private static void AndExpr() {
		EqualityExpr();
		while (t.kind==49) {
			Get();
			EqualityExpr();
		}
	}

	private static void ExclOrExpr() {
		AndExpr();
		while (t.kind==48) {
			Get();
			AndExpr();
		}
	}

	private static void InclOrExpr() {
		ExclOrExpr();
		while (t.kind==47) {
			Get();
			ExclOrExpr();
		}
	}

	private static void CondAndExpr() {
		InclOrExpr();
		while (t.kind==46) {
			Get();
			InclOrExpr();
		}
	}

	private static void CondOrExpr() {
		CondAndExpr();
		while (t.kind==45) {
			Get();
			CondAndExpr();
		}
	}

	private static void AssignOp() {
		switch (t.kind) {
		case 34: {
			Get();
			break;
		}
		case 74: {
			Get();
			break;
		}
		case 75: {
			Get();
			break;
		}
		case 76: {
			Get();
			break;
		}
		case 77: {
			Get();
			break;
		}
		case 78: {
			Get();
			break;
		}
		case 79: {
			Get();
			break;
		}
		case 80: {
			Get();
			break;
		}
		case 81: {
			Get();
			break;
		}
		case 82: {
			Get();
			break;
		}
		case 83: {
			Get();
			break;
		}
		case 84: {
			Get();
			break;
		}
		default: Error(92);
		}
	}

	private static void CondExpr() {
		CondOrExpr();
		if (t.kind==43) {
			Get();
			Expr();
			Expect(44);
			CondExpr();
		}
	}

	private static void ArrayInitializer() {
		Expect(25);
		if (StartOf(6)) {
			VarInitializer();
			while (t.kind==24) {
				Get();
				if (StartOf(6)) {
					VarInitializer();
				}
			}
		}
		Expect(26);
	}

	private static void Expr() {
		CondExpr();
		if (StartOf(7)) {
			AssignOp();
			Expr();
		}
	}

	private static JavaAttributeInfo VarDeclarator(String partype) {
		JavaAttributeInfo ai;
		Expect(1);
		ai = new JavaAttributeInfo(token.val, partype); 
		ai.position = Scanner.line;
		while (t.kind==28) {
			Get();
			Expect(29);
			ai.arraydim++; 
		}
		if (t.kind==34) {
			Get();
			VarInitializer();
		}
		return ai;
	}

	private static void VarInitializer() {
		if (StartOf(1)) {
			Expr();
		} else if (t.kind==25) {
			ArrayInitializer();
		} else Error(93);
	}

	private static String Type() {
		String typename;
		typename = new String("undef"); 
		if (StartOf(2)) {
			typename = PrimitiveType();
		} else if (t.kind==1) {
			typename = Name();
		} else Error(94);
		while (t.kind==28) {
			Get();
			Expect(29);
		}
		return typename;
	}

	private static Parameter FormPar() {
		Parameter parameter;
		String partype; parameter = null;
		modifierPool jt = modifierPool.javaTypes(); 
		partype = Type();
		Expect(1);
		String parname = token.val;
		parameter = new Parameter(parname, partype); 
		while (t.kind==28) {
			Get();
			Expect(29);
			parameter.arraydim++; 
		}
		return parameter;
	}

	private static void FormParList(JavaMethodInfo mi) {
		Parameter par; 
		par = FormPar();
		mi.addParameter(par); 
		while (t.kind==24) {
			Get();
			par = FormPar();
			mi.addParameter(par); 
		}
	}

	private static Vector FieldRest(String parname, String partype, BitSet mods) {
		Vector attr;
		JavaAttributeInfo ai = new JavaAttributeInfo(parname, partype);
		ai.position = Scanner.line;
		attr = new Vector(3);
		ai.setModifiers(mods);
		attr.addElement(ai);
		
		while (t.kind==28) {
			Get();
			Expect(29);
			ai.arraydim++; 
		}
		if (t.kind==34) {
			Get();
			VarInitializer();
		}
		while (t.kind==24) {
			Get();
			ai = VarDeclarator(partype);
			ai.setModifiers(mods); 
			attr.addElement(ai);    
		}
		Expect(7);
		return attr;
	}

	private static JavaMethodInfo MethodRest(String mname, String rettype) {
		JavaMethodInfo mi;
		
		String dummy; mi = new JavaMethodInfo(mname, rettype); 
		mi.position = Scanner.line;
		Expect(31);
		if (StartOf(8)) {
			FormParList(mi);
		}
		Expect(32);
		while (t.kind==28) {
			Get();
			Expect(29);
		}
		if (t.kind==33) {
			Get();
			dummy = Name();
			while (t.kind==24) {
				Get();
				dummy = Name();
			}
		}
		if (t.kind==7) {
			Get();
		} else if (t.kind==25) {
			Block();
			if (t.kind==7) {
				Get();
			}
		} else Error(95);
		return mi;
	}

	private static String PrimitiveType() {
		String typename;
		switch (t.kind) {
		case 35: {
			Get();
			break;
		}
		case 36: {
			Get();
			break;
		}
		case 37: {
			Get();
			break;
		}
		case 38: {
			Get();
			break;
		}
		case 39: {
			Get();
			break;
		}
		case 40: {
			Get();
			break;
		}
		case 41: {
			Get();
			break;
		}
		case 42: {
			Get();
			break;
		}
		default: Error(96);
		}
		typename = token.val; 
		return typename;
	}

	private static void InnerClass() {
		String dummy; 
		Expect(21);
		Expect(1);
		if (t.kind==22) {
			Get();
			dummy = Name();
		}
		if (t.kind==23) {
			Get();
			dummy = Name();
			while (t.kind==24) {
				Get();
				dummy = Name();
			}
		}
		Block();
	}

	private static void Block() {
		Expect(25);
		// scan for end of method, hand written code!
		int depth;
		if (t.kind == 26) depth = 0;
		else depth = 1;
		while ((depth > 0) && (Scanner.ch != Scanner.EOF)){
			Get();
			if (t.kind == 25) depth++;
			else if (t.kind == 26) depth--;
		}
		
		Expect(26);
	}

	private static void Decl(JavaClassInfo ci, BitSet mods) {
		int arrayCount = 0; String name1="", name2="";
		Vector attr=null; JavaMethodInfo meth=null; 
		if (StartOf(8)) {
			if (StartOf(2)) {
				name1 = PrimitiveType();
				while (t.kind==28) {
					Get();
					Expect(29);
					arrayCount++; 
				}
				Expect(1);
				name2 = token.val; 
			} else {
				name2 = Name();
				while (t.kind==28) {
					Get();
					Expect(29);
					arrayCount++; 
				}
				if (t.kind==1) {
					Get();
					name1 = name2; name2 = token.val; 
				}
			}
			if (t.kind==31) {
				meth = MethodRest(name2, name1);
				meth.setModifiers(mods); 
			} else if (StartOf(9)) {
				attr = FieldRest(name2, name1, mods);
			} else Error(97);
		} else if (t.kind==30) {
			Get();
			Expect(1);
			name1 = "void"; name2 = token.val; 
			meth = MethodRest(name2, name1);
		} else Error(98);
		if (meth != null) ci.addMethod(meth); 
		if (attr != null){
		for (Enumeration e = attr.elements(); e.hasMoreElements();){
		JavaAttributeInfo ai = (JavaAttributeInfo)e.nextElement();
		ci.addAttribute(ai);
		}
		}
		
	}

	private static void InterfaceDecl() {
		BitSet dummy; String n;
		Expect(27);
		Expect(1);
		if (t.kind==22) {
			Get();
			n = Name();
			while (t.kind==24) {
				Get();
				n = Name();
			}
		}
		Expect(25);
		int depth;
		if (t.kind == 26) depth = 0;
		else depth = 1;
		while (depth > 0){
		Get();
		if (t.kind == 25) depth++;
		else if (t.kind == 26) depth--;
		}
		
		Expect(26);
	}

	private static JavaClassInfo ClassDecl() {
		JavaClassInfo ci;
		String classname, sname, dummy; BitSet mods=null; 
		JavaAttributeInfo attr;
		JavaMethodInfo method;
		int errorCount = Scanner.err.count;

		Expect(21);
		sname = "java.lang.Object";
		Expect(1);
		classname = token.val; 
		if (t.kind==22) {
			Get();
			sname = Name();
		}
		ci = new JavaClassInfo(classname, sname); 
		ci.position = Scanner.line;
		if (t.kind==23) {
			
			Get();
			dummy = Name();
			while (t.kind==24) {
				Get();
				dummy = Name();
			}
		}
		Expect(25);
		while (StartOf(10)) {
			mods = Modifiers();
			if (StartOf(11)) {
				Decl(ci, mods);
			} else if (t.kind==25) {
				Block();
				
			} else if (t.kind==21) {
				InnerClass();
			} else Error(99);
		}
		Expect(26);
		if (errorCount == Scanner.err.count) ci.valid = true;
		return ci;
	}

	private static BitSet Modifiers() {
		BitSet mods;
		mods = new BitSet(10); 
		while (StartOf(12)) {
			switch (t.kind) {
			case 11: {
				Get();
				break;
			}
			case 12: {
				Get();
				break;
			}
			case 13: {
				Get();
				break;
			}
			case 14: {
				Get();
				break;
			}
			case 15: {
				Get();
				break;
			}
			case 16: {
				Get();
				break;
			}
			case 17: {
				Get();
				break;
			}
			case 18: {
				Get();
				break;
			}
			case 19: {
				Get();
				break;
			}
			case 20: {
				Get();
				break;
			}
			}
			mods.set(mod.mapMod(token.val)); 
		}
		return mods;
	}

	private static String Name() {
		String name;
		Expect(1);
		StringBuffer n = new StringBuffer(token.val); 
		while (t.kind==9) {
			Get();
			n.append("."); 
			Expect(1);
			n.append(token.val); 
		}
		name = n.toString(); 
		return name;
	}

	private static void SID() {
		BitSet mods; JavaClassInfo ci=null; String packageName=""; 
		Vector imports = new Vector(5); StringBuffer imp; 
		boolean simple;

		if (t.kind==6) {
			Get();
			packageName = Name();
			Expect(7);
			imports.addElement(new JavaImport(packageName, false)); 
		}
		while (t.kind==8) {
			Get();
			Expect(1);
			imp = new StringBuffer(token.val); simple = true; 
			while (t.kind==9) {
				Get();
				imp.append("."); 
				if (t.kind==1) {
					Get();
					imp.append(token.val); 
				} else if (t.kind==10) {
					Get();
					simple = false; 
				} else Error(100);
			}
			Expect(7);
			if (simple) imports.addElement(new JavaImport(imp.toString(), simple));
			else imports.addElement(new JavaImport(imp.toString().substring(0, imp.length()-1), simple));
			
		}
		while (StartOf(13)) {
			if (t.kind==7) {
				Get();
			} else {
				mods = Modifiers();
				if (t.kind==21) {
					ci = ClassDecl();
					ci.setModifiers(mods);
					if (packageName.length() > 0)
					ci.name = packageName + "." + ci.name;
					if (ci.name.equals(ci.superName)){		// only java.lang.Object
					ci.superName = "";
					}
					for (Enumeration e = imports.elements(); e.hasMoreElements();){
					ci.addImport((JavaImport)e.nextElement());
					}
					parsedClasses.addElement(ci); 
				} else if (t.kind==27) {
					InterfaceDecl();
				} else Error(101);
			}
		}
	}



	public static void Parse() {
		t = new Token();
		Get();
		SID();
	}

	static boolean[][] set = {
	{T,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x},
	{x,T,T,T, T,T,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,T, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, T,T,x,x, T,T,T,T, T,T,T,T, T,T,x,x, x,x,x,x, x,x,x,x, x,x,x},
	{x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,T, T,T,T,T, T,T,T,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x},
	{x,T,T,T, T,T,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,T, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, T,T,T,T, T,T,x,x, x,x,x,x, x,x,x,x, x,x,x},
	{x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, T,T,x,x, T,T,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x},
	{x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, T,T,T,T, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x},
	{x,T,T,T, T,T,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,T,x,x, x,x,x,T, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, T,T,x,x, T,T,T,T, T,T,T,T, T,T,x,x, x,x,x,x, x,x,x,x, x,x,x},
	{x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,T,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,T,T, T,T,T,T, T,T,T,T, T,x,x},
	{x,T,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,T, T,T,T,T, T,T,T,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x},
	{x,x,x,x, x,x,x,T, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, T,x,x,x, T,x,x,x, x,x,T,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x},
	{x,T,x,x, x,x,x,x, x,x,x,T, T,T,T,T, T,T,T,T, T,T,x,x, x,T,x,x, x,x,T,x, x,x,x,T, T,T,T,T, T,T,T,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x},
	{x,T,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,T,x, x,x,x,T, T,T,T,T, T,T,T,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x},
	{x,x,x,x, x,x,x,x, x,x,x,T, T,T,T,T, T,T,T,T, T,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x},
	{x,x,x,x, x,x,x,T, x,x,x,T, T,T,T,T, T,T,T,T, T,T,x,x, x,x,x,T, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x,x, x,x,x}

	};
}
/*
class ErrorStream {

	int count;	// number of errors detected
	
	ErrorStream() {
		count = 0;
	}
	
	void ParsErr(int n, int line, int col) {
		String s;
		count++;
		System.out.print("-- line " + line + " col " + col + ": ");
		switch (n) {
			case 0: {s = "EOF expected"; break;}
			case 1: {s = "ident expected"; break;}
			case 2: {s = "integer expected"; break;}
			case 3: {s = "float expected"; break;}
			case 4: {s = "char expected"; break;}
			case 5: {s = "string expected"; break;}
			case 6: {s = "'package' expected"; break;}
			case 7: {s = "';' expected"; break;}
			case 8: {s = "'import' expected"; break;}
			case 9: {s = "'.' expected"; break;}
			case 10: {s = "'*' expected"; break;}
			case 11: {s = "'public' expected"; break;}
			case 12: {s = "'protected' expected"; break;}
			case 13: {s = "'private' expected"; break;}
			case 14: {s = "'static' expected"; break;}
			case 15: {s = "'abstract' expected"; break;}
			case 16: {s = "'final' expected"; break;}
			case 17: {s = "'native' expected"; break;}
			case 18: {s = "'synchronized' expected"; break;}
			case 19: {s = "'transient' expected"; break;}
			case 20: {s = "'volatile' expected"; break;}
			case 21: {s = "'class' expected"; break;}
			case 22: {s = "'extends' expected"; break;}
			case 23: {s = "'implements' expected"; break;}
			case 24: {s = "',' expected"; break;}
			case 25: {s = "'{' expected"; break;}
			case 26: {s = "'}' expected"; break;}
			case 27: {s = "'interface' expected"; break;}
			case 28: {s = "'[' expected"; break;}
			case 29: {s = "']' expected"; break;}
			case 30: {s = "'void' expected"; break;}
			case 31: {s = "'(' expected"; break;}
			case 32: {s = "')' expected"; break;}
			case 33: {s = "'throws' expected"; break;}
			case 34: {s = "'=' expected"; break;}
			case 35: {s = "'boolean' expected"; break;}
			case 36: {s = "'byte' expected"; break;}
			case 37: {s = "'short' expected"; break;}
			case 38: {s = "'int' expected"; break;}
			case 39: {s = "'long' expected"; break;}
			case 40: {s = "'char' expected"; break;}
			case 41: {s = "'float' expected"; break;}
			case 42: {s = "'double' expected"; break;}
			case 43: {s = "'?' expected"; break;}
			case 44: {s = "':' expected"; break;}
			case 45: {s = "'||' expected"; break;}
			case 46: {s = "'&&' expected"; break;}
			case 47: {s = "'|' expected"; break;}
			case 48: {s = "'^' expected"; break;}
			case 49: {s = "'&' expected"; break;}
			case 50: {s = "'==' expected"; break;}
			case 51: {s = "'!=' expected"; break;}
			case 52: {s = "'<' expected"; break;}
			case 53: {s = "'>' expected"; break;}
			case 54: {s = "'<=' expected"; break;}
			case 55: {s = "'>=' expected"; break;}
			case 56: {s = "'instanceof' expected"; break;}
			case 57: {s = "'>>' expected"; break;}
			case 58: {s = "'<<' expected"; break;}
			case 59: {s = "'>>>' expected"; break;}
			case 60: {s = "'+' expected"; break;}
			case 61: {s = "'-' expected"; break;}
			case 62: {s = "'/' expected"; break;}
			case 63: {s = "'%' expected"; break;}
			case 64: {s = "'++' expected"; break;}
			case 65: {s = "'--' expected"; break;}
			case 66: {s = "'~' expected"; break;}
			case 67: {s = "'!' expected"; break;}
			case 68: {s = "'true' expected"; break;}
			case 69: {s = "'false' expected"; break;}
			case 70: {s = "'null' expected"; break;}
			case 71: {s = "'this' expected"; break;}
			case 72: {s = "'super' expected"; break;}
			case 73: {s = "'new' expected"; break;}
			case 74: {s = "'*=' expected"; break;}
			case 75: {s = "'/+=' expected"; break;}
			case 76: {s = "'%=' expected"; break;}
			case 77: {s = "'+=' expected"; break;}
			case 78: {s = "'-=' expected"; break;}
			case 79: {s = "'<<=' expected"; break;}
			case 80: {s = "'>>=' expected"; break;}
			case 81: {s = "'>>>=' expected"; break;}
			case 82: {s = "'&=' expected"; break;}
			case 83: {s = "'^=' expected"; break;}
			case 84: {s = "'|=' expected"; break;}
			case 85: {s = "??? expected"; break;}
			case 86: {s = "invalid Primary"; break;}
			case 87: {s = "invalid Primary"; break;}
			case 88: {s = "invalid Primary"; break;}
			case 89: {s = "invalid Primary"; break;}
			case 90: {s = "invalid Primary"; break;}
			case 91: {s = "invalid UnaryExpr0"; break;}
			case 92: {s = "invalid AssignOp"; break;}
			case 93: {s = "invalid VarInitializer"; break;}
			case 94: {s = "invalid Type"; break;}
			case 95: {s = "invalid MethodRest"; break;}
			case 96: {s = "invalid PrimitiveType"; break;}
			case 97: {s = "invalid Decl"; break;}
			case 98: {s = "invalid Decl"; break;}
			case 99: {s = "invalid ClassDecl"; break;}
			case 100: {s = "invalid SID"; break;}
			case 101: {s = "invalid SID"; break;}

			default: s = "error " + n;
		}
		System.out.println(s);
	}
	
	void SemErr(int n, int line, int col) {
		count++;
		System.out.print("-- line " + line + " col " + col + ": ");
	}
	
	void Exception (String s) {
		System.out.println(s); System.exit(0);
	}
	
}
*/
