// project: SID - Structured Interactive Documentation
// author : Dipl.Ing. Stefan Chiettini

package SID.Utils;

import java.util.*;
import java.awt.*;

public final class ColorPool{

	private static Color[] cols = new Color[13];

	static{
		cols[0] = Color.black;
		cols[1] = Color.blue;
		cols[2] = Color.cyan;
		cols[3] = Color.darkGray;
		cols[4] = Color.gray;
		cols[5] = Color.green;
		cols[6] = Color.lightGray;
		cols[7] = Color.magenta;
		cols[8] = Color.orange;
		cols[9] = Color.pink;
		cols[10] = Color.red;
	    cols[11] = Color.white;
	    cols[12] = Color.yellow;
	}

	public static Color getColor(int r, int g, int b){
		for (int i = 0; i<=12; i++){
			if ((r == cols[i].getRed()) && (g == cols[i].getGreen()) && (b == cols[i].getBlue()))
				return cols[i];
		}

		return new Color(r, g, b);
	}

	public static int getColIndex(int r, int g, int b){
		for (int i = 0; i<=12; i++){
			if ((r == cols[i].getRed()) && (g == cols[i].getGreen()) && (b == cols[i].getBlue()))
				return i;
		}

		return 0;
	}

	public static Color getColByIndex(int idx){
		return cols[idx];
	}
}